/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://bitbucket.org/tidalwave/openbluesky-src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.examples.nodes.example8.view;

import javax.annotation.Nonnull;
import javax.swing.JComponent;
import it.tidalwave.netbeans.swing.role.ComponentProvider;
import it.tidalwave.netbeans.nodes.role.CompositeNodeDecorator;
import it.tidalwave.netbeans.nodes.role.NodeDecorator;
import it.tidalwave.netbeans.nodes.role.RootNodeProvider;
import it.tidalwave.netbeans.nodes.role.SortableNodeDecorator;
import it.tidalwave.netbeans.examples.nodes.example1.util.Launcher;
import it.tidalwave.netbeans.examples.nodes.example2.view.GenericTreePanel2;
import it.tidalwave.netbeans.examples.nodes.example6.view.FileSystemRootNodeProvider4;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class NodesExample8 implements ComponentProvider
  {
    @Override @Nonnull
    public JComponent createComponent() 
      {
        final String userHome = System.getProperty("user.home");
        final RootNodeProvider rootNodeProvider = new FileSystemRootNodeProvider4(userHome);
        final NodeDecorator nodeDecorator1 = new SortableNodeDecorator();
        final NodeDecorator nodeDecorator2 = new SortActionsNodeDecorator();
        final NodeDecorator nodeDecorator = new CompositeNodeDecorator(nodeDecorator1, nodeDecorator2);
        return new GenericTreePanel2(rootNodeProvider, nodeDecorator);
      }
    
    public static void main (final @Nonnull String ... args) 
      {
        Launcher.run(new NodesExample8(), "Nodes Example 8");
      }
  }
